
data (==) {A : Set}(a : A) : A -> Set where
  refl : a == a

infix 4 ==

sym (A : Set)(x, y : A) : x == y -> y == x
sym refl = refl

trans (A : Set)(x, z : A) : (y : A) -> x == y -> y == z -> x == z
trans _ refl eq = eq

subst (A : Set)(x, y : A) : (P : A -> Set) -> x == y -> P x -> P y
subst P refl px = px

cong (A, B : Set)(x, y : A) : (f : A -> B) -> x == y -> f x == f y
cong f refl = refl

cong2 (A, B, C : Set)(x1, x2 : A)(y1, y2 : B) :
    (f : A -> B -> C) -> x1 == x2 -> y1 == y2 -> f x1 y1 == f x2 y2
cong2 f refl refl = refl

