-- # import Property

D : Set

W : D -> (D -> D -> Prop) -> D -> D -> Prop
W a R x y = R x y \/ (R x a /\ R a y)

TN : (D -> D -> Prop) -> D -> Prop
TN R a = (x : D) -> (y : D) -> R x a ==> R a y ==> R x y

lem1 : (a : D) -> (R : D -> D -> Prop) -> TN (W a R) a
lem1 a R x y = impI (\h1 -> 
               impI (\h2 -> fol-plugin(h1,h2)))

lem2 : (a : D) -> (b : D) -> (R : D -> D -> Prop) -> TN R b ==> TN (W a R) b
lem2 a b R = impI (\h1 -> \x y -> 
             impI (\h2 -> 
             impI (\h3 -> fol-plugin(h1,h2,h3))))

test : (a : D) -> (b : D) -> (R : D -> D -> Prop) ->
        (x : D) -> (y : D) -> W b (W a R) x y <=> W a (W b R) x y
test a b R x y = fol-plugin()


inclus : (D -> D -> Prop) -> (D -> D -> Prop) -> Prop
inclus R S = (x : D) -> (y : D) -> R x y ==> S x y

lem3 : (R : D -> D -> Prop) -> (S : D -> D -> Prop) -> (a : D) ->
        inclus R S ==> TN S a ==> inclus (W a R) S
lem3 R S a = impI (\h1 ->
             impI (\h2 -> \x y -> 
             impI (\h3 -> fol-plugin(h1,h2,h3))))

lem4 : (a : D) -> (R : D -> D -> Prop) ->
        (x : D) -> (y : D) -> W a (W a R) x y <=> W a R x y
lem4 a R x y = fol-plugin()

lem5 : (a : D) -> (R : D -> D -> Prop) -> inclus R (W a R)
lem5 a R x y = impI (\h1 -> fol-plugin(h1))

